from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..types import UNSET, Unset

T = TypeVar("T", bound="TokenInfo")


@attr.s(auto_attribs=True)
class TokenInfo:
    """ """

    id: "Union[Unset, str]" = UNSET
    client: "Union[Unset, str]" = UNSET
    user: "Union[Unset, str]" = UNSET
    scope: "Union[Unset, List[str]]" = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        id = self.id
        client = self.client
        user = self.user
        scope: Union[Unset, List[str]] = UNSET
        if not isinstance(self.scope, Unset):
            scope = self.scope

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if id is not UNSET:
            field_dict["id"] = id
        if client is not UNSET:
            field_dict["client"] = client
        if user is not UNSET:
            field_dict["user"] = user
        if scope is not UNSET:
            field_dict["scope"] = scope

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:

        d = src_dict.copy()

        id = d.pop("id", UNSET)

        client = d.pop("client", UNSET)

        user = d.pop("user", UNSET)

        scope = cast(List[str], d.pop("scope", UNSET))

        token_info = cls(
            id=id,
            client=client,
            user=user,
            scope=scope,
        )

        token_info.additional_properties = d
        return token_info

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
